#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.
uniform float brightness;
uniform float t;

void main(void)
{
	float r=length(gl_Vertex.xy)+0.01;
	vec2 base = gl_Vertex.xy*(1.0/r);
	float u=(gl_Vertex.z+1);
  vec2 cs=vec2(cos(u*t),-sin(u*t));
  vec3 vert=vec3(2.0*base + cs.x*gl_Vertex.xy, r*cs.y);
  vec3 vel=u*vec3(-gl_Vertex.xy*cs.y, r*cs.x);

  vec4 camera_pos = gl_ModelViewMatrixInverse[3];
	vec4 pos = gl_ModelViewProjectionMatrix * vec4(vert, 1.0);

	vec3 delta=(gl_ModelViewMatrix*gl_Vertex).xyz;

	float br=dot(normalize(gl_Vertex-camera_pos).xyz,vel);
	br=abs(br);

	float l=dot(delta,delta);
	gl_Position=pos;
	float q=exp2(255.0*gl_Color.a-119.0);
	vec3 col=gl_Color.rgb*(q*brightness*br/(l+0.1));
	gl_FrontColor=vec4(col.r,col.g*br,col.b*br*br,1.0);
}
