#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.

uniform float brightness;
uniform float interp_t;
attribute vec3 old_vertex;
/*
a/(e^(b/T)-1)
f = frequency
a=2hf^3/c^2
b=hf/k
*/
const float min_temp=1000.0;
const float max_temp=30000.0;

const float temp_q_a=log(min_temp);
const float temp_q_b_inv=(log(max_temp)-temp_q_a);
const float t_white=6000.0;
const float b_r=22135.0;
const float b_g=26159.0;
const float b_b=31972.0;
const float a_r=exp(b_r/6000.0)-1.0;
const float a_g=exp(b_g/6000.0)-1.0;
const float a_b=exp(b_b/6000.0)-1.0;

void main(void)
{
   vec4 camera_pos = gl_ModelViewMatrixInverse[3];

   vec3 interp_vert=old_vertex+(gl_Vertex.xyz-old_vertex)*interp_t;

   vec4 pos = gl_ModelViewProjectionMatrix * vec4(interp_vert, 1.0);


   vec3 delta=interp_vert-camera_pos.xyz;
   float l=dot(delta,delta);
   gl_Position=pos;
   float t=exp(gl_Color.a*temp_q_b_inv + temp_q_a);
   vec3 blackbody_color=vec3(a_r/(exp(b_r/t)-1.0), a_g/(exp(b_g/t)-1.0), a_b/(exp(b_b/t)-1.0));
   gl_FrontColor=vec4(gl_Color.rgb*blackbody_color*(brightness/l),1.0);//vec4(gl_Color.rgb*blackbody_color*(brightness/l),1);
}
